Index: DirectShowFilters/TsWriter/MPTSWriter.vcproj
===================================================================
--- DirectShowFilters/TsWriter/MPTSWriter.vcproj	(revision 27484)
+++ DirectShowFilters/TsWriter/MPTSWriter.vcproj	(working copy)
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="Windows-1252"?>
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="9,00"
+	Version="9.00"
 	Name="TsWriter"
 	ProjectGUID="{FCF30D16-2C9E-4429-B605-4ACA43023E71}"
 	RootNamespace="MPTSWriter"
@@ -317,6 +317,30 @@
 					>
 				</File>
 				<File
+					RelativePath=".\source\SkyChannelDecoder.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\source\SkyChannelParser.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\source\SkyEpgParser.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\source\SkyEpgSummaryDecoder.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\source\SkyEpgTitleDecoder.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\source\SkyManager.cpp"
+					>
+				</File>
+				<File
 					RelativePath=".\source\VirtualChannelTableParser.cpp"
 					>
 				</File>
@@ -360,6 +384,22 @@
 					RelativePath=".\source\EnterCriticalSection.cpp"
 					>
 				</File>
+				<File
+					RelativePath=".\source\HuffmanBranchNode.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\source\HuffmanLeafNode.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\source\HuffmanNode.cpp"
+					>
+				</File>
+				<File
+					RelativePath=".\source\HuffmanTree.cpp"
+					>
+				</File>
 			</Filter>
 		</Filter>
 		<Filter
@@ -470,6 +510,30 @@
 					>
 				</File>
 				<File
+					RelativePath=".\source\SkyChannelDecoder.h"
+					>
+				</File>
+				<File
+					RelativePath=".\source\SkyChannelParser.h"
+					>
+				</File>
+				<File
+					RelativePath=".\source\SkyEpgParser.h"
+					>
+				</File>
+				<File
+					RelativePath=".\source\SkyEpgSummaryDecoder.h"
+					>
+				</File>
+				<File
+					RelativePath=".\source\SkyEpgTitleDecoder.h"
+					>
+				</File>
+				<File
+					RelativePath=".\source\SkyManager.h"
+					>
+				</File>
+				<File
 					RelativePath=".\source\VirtualChannelTableParser.h"
 					>
 				</File>
@@ -501,6 +565,26 @@
 					RelativePath=".\source\EnterCriticalSection.h"
 					>
 				</File>
+				<File
+					RelativePath=".\source\HuffmanBranchNode.h"
+					>
+				</File>
+				<File
+					RelativePath=".\source\HuffmanLeafNode.h"
+					>
+				</File>
+				<File
+					RelativePath=".\source\HuffmanNode.h"
+					>
+				</File>
+				<File
+					RelativePath=".\source\HuffmanTree.h"
+					>
+				</File>
+				<File
+					RelativePath=".\source\SkyThemes.h"
+					>
+				</File>
 			</Filter>
 			<Filter
 				Name="SHARED"
Index: DirectShowFilters/TsWriter/source/EpgScanner.cpp
===================================================================
--- DirectShowFilters/TsWriter/source/EpgScanner.cpp	(revision 27484)
+++ DirectShowFilters/TsWriter/source/EpgScanner.cpp	(working copy)
@@ -56,6 +56,7 @@
 	m_bGrabbing=false;
 	m_epgParser.Reset();
   m_mhwParser.Reset();
+	skyManager.Reset();
 	return S_OK;
 }
 
@@ -66,6 +67,7 @@
 	m_bGrabbing=false;
 	m_epgParser.AbortGrabbing();
 	m_mhwParser.AbortGrabbing();
+	skyManager.DeActivateEpgGrabber();
 	if (m_pCallBack!=NULL)
 	{
 		LogDebug("epg: do callback");
@@ -277,6 +279,113 @@
 	return S_OK;
 }
 
+//	Activates the Sky epg grabber
+STDMETHODIMP CEpgScanner::ActivateSkyEpgGrabber(UINT activateCountryId)
+{
+	CEnterCriticalSection enter(m_section);
+	try
+	{
+		skyManager.ActivateEpgGrabber(activateCountryId);
+		m_bGrabbing=true;
+	}
+	catch(...)
+	{
+		LogDebug("CEpgScanner::ActivateSkyEpgGrabber() - Exception when activating Sky Epg grabber");
+	}
+	return S_OK;
+}
+
+//	Gets if the sky epg grabber is active
+STDMETHODIMP CEpgScanner::IsSkyEpgGrabberActive(byte* active)
+{
+		LogDebug("CEpgScanner::IsSkyEpgGrabberActive()");
+	CEnterCriticalSection enter(m_section);
+	try
+	{
+		*active = (skyManager.IsEpgGrabbingActive() ? 1 : 0);
+	}
+	catch(...)
+	{
+		LogDebug("CEpgScanner::IsSkyEpgGrabberActive() - Exception");
+	}
+	return S_OK;
+}
+
+//	Gets if the sky epg is ready to be retrieved
+STDMETHODIMP CEpgScanner::IsSkyEpgReady(byte* ready)
+{
+		LogDebug("CEpgScanner::IsSkyEpgReady()");
+	CEnterCriticalSection enter(m_section);
+	try
+	{
+		*ready = (skyManager.IsEpgGrabbingFinished() ? 1 : 0);
+	}
+	catch(...)
+	{
+		LogDebug("CEpgScanner::ActivateSkyEpgGrabber() - Exception");
+	}
+	return S_OK;
+}
+//	Gets if the sky epg grabbing has been aborted
+STDMETHODIMP CEpgScanner::HasSkyEpgAborted(byte* aborted)
+{
+	LogDebug("CEpgScanner::HasSkyEpgAborted()");
+	CEnterCriticalSection enter(m_section);
+	try
+	{
+		*aborted = (skyManager.HasEpgGrabbingAborted() ? 1 : 0);
+	}
+	catch(...)
+	{
+		LogDebug("CEpgScanner::HasSkyEpgAborted() - Exception");
+	}
+	return S_OK;
+}
+//	Resets the epg retrieval
+STDMETHODIMP CEpgScanner::ResetSkyEpgRetrieval()
+{
+		LogDebug("CEpgScanner::ResetEpgRetrieval()");
+	CEnterCriticalSection enter(m_section);
+	try
+	{
+		skyManager.ResetEpgRetrieval();
+	}
+	catch(...)
+	{
+		LogDebug("CEpgScanner::ResetEpgRetrieval() - Exception when resetting epg retrieval for Sky");
+	}
+	return S_OK;
+}
+//	Gets the next Sky epg channel
+STDMETHODIMP CEpgScanner::GetNextSkyEpgChannel(unsigned char* isLastChannel, unsigned short* channelId, unsigned short* networkId, unsigned short* transportId, unsigned short* serviceId)
+{
+	try
+	{
+		skyManager.GetNextSkyEpgChannel(isLastChannel, channelId, networkId, transportId, serviceId);
+	}
+	catch(...)
+	{
+		LogDebug("CEpgScanner::GetNextSkyEpgChannel() - Exception when retrieving next Sky epg channel");
+	}
+
+	return S_OK;
+}
+
+//	Gets the next Sky epg channel event
+STDMETHODIMP CEpgScanner::GetNextSkyEpgChannelEvent(unsigned char* isLastChannelEvent, unsigned short* eventId, unsigned short* mjdStart, unsigned int* startTime, unsigned int* duration, unsigned char** title, unsigned char** summary, unsigned char** theme, unsigned short* seriesId, byte* seriesTermination)
+{
+	try
+	{
+		skyManager.GetNextSkyEpgChannelEvent(isLastChannelEvent, eventId, mjdStart, startTime, duration, title, summary, theme, seriesId, seriesTermination);
+	}
+	catch(...)
+	{
+		LogDebug("CEpgScanner::GetNextSkyEpgChannelEvent() - Exception when retrieving next Sky epg channel event");
+	}
+
+	return S_OK;
+}
+
 bool CEpgScanner::IsEPG_PID(int pid)
 {
 	return (pid==PID_EPG || 
@@ -295,34 +404,82 @@
 
 bool CEpgScanner::IsEIT_PID(int pid)
 {
-	return (IsEPG_PID(pid) || IsMHW_PID(pid));
+	return (IsEPG_PID(pid) || IsMHW_PID(pid)) || IsSkyEpg_PID(pid);
 }
 
+//	Does the pid carry Sky Epg data?
+bool CEpgScanner::IsSkyEpg_PID(int pid)
+{
+	return skyManager.DoesPidCarryChannelNetworkData(pid) || skyManager.DoesPidCarryEpgData(pid);
+}
+
 void CEpgScanner::OnTsPacket(byte* tsPacket)
 {
   if (!m_bGrabbing) return;
 	try
 	{
 		int pid=((tsPacket[1] & 0x1F) <<8)+tsPacket[2];
-		if (!IsEIT_PID(pid)) return;
+
+		if (!IsEIT_PID(pid)) 
+			return;
+		
+		m_header.Decode(tsPacket);
+		CEnterCriticalSection enter(m_section);
+
+		if (IsEPG_PID(pid))
+			m_epgParser.OnTsPacket(m_header, tsPacket);
+		else if(IsMHW_PID(pid))
+			m_mhwParser.OnTsPacket(m_header, tsPacket);
+		else if(IsSkyEpg_PID(pid))
+			skyManager.OnTsPacket(m_header, tsPacket);
+
+		bool isSkyEpgGrabberActive = skyManager.IsEpgGrabbingActive();
+
+		//	If sky is active, we can ignore the other grabbers
+		if(isSkyEpgGrabberActive)
 		{
-			m_header.Decode(tsPacket);
-			CEnterCriticalSection enter(m_section);
-			if (IsEPG_PID(pid))
-				m_epgParser.OnTsPacket(m_header,tsPacket);
-			else
-				m_mhwParser.OnTsPacket(m_header,tsPacket);
-			if (m_epgParser.IsEPGReady() && m_mhwParser.IsEPGReady())
+			//	If sky finished or aborted?
+			if(skyManager.IsEpgGrabbingFinished())
 			{
 				LogDebug("epg: epg received");
 				if (m_pCallBack!=NULL)
 				{
 					LogDebug("epg: do callback");
+
+					//	Notify manager we are finished
+					skyManager.OnEpgCallback();
+
 					m_pCallBack->OnEpgReceived();
 				}
 				m_bGrabbing=false;
 			}
-  	}
+
+			if(skyManager.HasEpgGrabbingAborted())
+			{
+				LogDebug("epg: Sky EPG grabbing aborted");
+				if (m_pCallBack!=NULL)
+				{
+					LogDebug("epg: do callback");
+					m_pCallBack->OnEpgReceived();
+				}
+				m_bGrabbing=false;
+			}
+		}
+		else
+		{
+			if(m_epgParser.IsEPGReady() && m_mhwParser.IsEPGReady())
+			{
+				LogDebug("epg: epg received");
+				if (m_pCallBack!=NULL)
+				{
+					LogDebug("epg: do callback");
+					m_pCallBack->OnEpgReceived();
+				}
+				m_bGrabbing=false;
+			}
+		}
+
+		
 	}
 	catch(...)
 	{
Index: DirectShowFilters/TsWriter/source/EpgScanner.h
===================================================================
--- DirectShowFilters/TsWriter/source/EpgScanner.h	(revision 27484)
+++ DirectShowFilters/TsWriter/source/EpgScanner.h	(working copy)
@@ -21,6 +21,7 @@
 #pragma once
 #include "epgparser.h"
 #include "mhwparser.h"
+#include "SkyManager.h"
 #include "criticalsection.h"
 #include "entercriticalsection.h"
 #include "..\..\shared\TsHeader.h"
@@ -59,6 +60,16 @@
 	STDMETHOD(GetMHWChannel)(THIS_ UINT channelNr, UINT* channelId, UINT* networkId, UINT* transportId, char** channelName)PURE;
 	STDMETHOD(GetMHWSummary)(THIS_ ULONG programId, char** summary)PURE;
 	STDMETHOD(GetMHWTheme)(THIS_ UINT themeId, char** theme)PURE;
+
+	//	Sky Epg grabbing
+	STDMETHOD(ActivateSkyEpgGrabber)(THIS_ UINT activateCountryId)PURE;
+	STDMETHOD(IsSkyEpgGrabberActive)(THIS_ byte* active)PURE;
+	STDMETHOD(IsSkyEpgReady)(THIS_ byte* ready)PURE;
+	STDMETHOD(HasSkyEpgAborted)(THIS_ byte* aborted)PURE;
+	STDMETHOD(ResetSkyEpgRetrieval)()PURE;
+	STDMETHOD(GetNextSkyEpgChannel)(THIS_ unsigned char* atEnd, unsigned short* channelId, unsigned short* networkId, unsigned short* transportId, unsigned short* serviceId)PURE;
+	STDMETHOD(GetNextSkyEpgChannelEvent)(THIS_ unsigned char* atEnd, unsigned short* eventId, unsigned short* mjdStart, unsigned int* startTime, unsigned int* duration, unsigned char** title, unsigned char** summary, unsigned char** theme, unsigned short* seriesId, byte* seriesTermination)PURE;
+
 	STDMETHOD(Reset)(THIS_)PURE;
 	STDMETHOD(AbortGrabbing)(THIS_)PURE;
   
@@ -89,6 +100,16 @@
 	STDMETHODIMP GetMHWChannel(UINT channelNr, UINT* channelId, UINT* networkId, UINT* transportId, char** channelName);
 	STDMETHODIMP GetMHWSummary(ULONG programId, char** summary);
 	STDMETHODIMP GetMHWTheme(UINT themeId, char** theme);
+
+	//	Sky Epg grabbing
+	STDMETHODIMP ActivateSkyEpgGrabber(UINT activateCountryId);
+	STDMETHODIMP IsSkyEpgGrabberActive(byte* active);
+	STDMETHODIMP IsSkyEpgReady(byte* ready);
+	STDMETHODIMP HasSkyEpgAborted(byte* aborted);
+	STDMETHODIMP ResetSkyEpgRetrieval();
+	STDMETHODIMP GetNextSkyEpgChannel(unsigned char* atEnd, unsigned short* channelId, unsigned short* networkId, unsigned short* transportId, unsigned short* serviceId);
+	STDMETHODIMP GetNextSkyEpgChannelEvent(unsigned char* atEnd, unsigned short* eventId, unsigned short* mjdStart, unsigned int* startTime, unsigned int* duration, unsigned char** title, unsigned char** summary, unsigned char** theme, unsigned short* seriesId, byte* seriesTermination);
+
 	STDMETHODIMP Reset();
 	STDMETHODIMP AbortGrabbing();
 	STDMETHODIMP SetCallBack(IEpgCallback* callback);
@@ -97,11 +118,13 @@
 protected:
 	CEpgParser m_epgParser;
 	CMhwParser m_mhwParser;
+	CSkyManager skyManager;
   IEpgCallback* m_pCallBack;
 
   	bool IsEPG_PID(int pid);
 	bool IsMHW_PID(int pid);
 	bool IsEIT_PID(int pid);
+	bool IsSkyEpg_PID(int pid);
 private:
 	bool m_bGrabbing;
 	CCriticalSection m_section;
Index: DirectShowFilters/TsWriter/source/HuffmanBranchNode.cpp
===================================================================
--- DirectShowFilters/TsWriter/source/HuffmanBranchNode.cpp	(revision 0)
+++ DirectShowFilters/TsWriter/source/HuffmanBranchNode.cpp	(revision 0)
@@ -0,0 +1,134 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+
+#include "HuffmanNode.h";
+#include "HuffmanBranchNode.h"
+
+
+//	External logging method
+extern void LogDebug(const char *fmt, ...) ;
+
+//	Cstr
+CHuffmanBranchNode::CHuffmanBranchNode()
+{
+	left = NULL;
+	right = NULL;
+}
+
+//	Flzr
+CHuffmanBranchNode::~CHuffmanBranchNode()
+{
+	if(left != NULL)
+		delete left;
+
+	if(right != NULL)
+		delete right;
+
+	LogDebug("CHuffmanBranchNode::flzr()");
+}
+
+//	Gets the type of this node (branch node)
+int CHuffmanBranchNode::GetType()
+{
+	return HUFFMAN_BRANCH_NODE;
+}
+
+//	Gets the left node
+CHuffmanNode* CHuffmanBranchNode::GetLeft()
+{
+	return left;
+}
+
+//	Sets the right node
+void CHuffmanBranchNode::SetLeft(CHuffmanNode* newLeft)
+{
+	left = newLeft;
+}
+
+//	Gets the right node
+CHuffmanNode* CHuffmanBranchNode::GetRight()
+{
+	return right;
+}
+
+//	Sets the right node
+void CHuffmanBranchNode::SetRight(CHuffmanNode* newRight)
+{
+	right = newRight;
+}
+
+//	Traverses the tree to decode the huffman data
+bool CHuffmanBranchNode::Decode(byte** currentInputByte, byte* currentInputBit, byte* endInputByte, byte** currentOutputByte, byte* endOutputByte, bool* hasFinished)
+{
+	byte testByte = **currentInputByte;
+
+	byte bitTest = 0x80 >> *currentInputBit;
+	
+	CHuffmanNode* nextNode;
+
+	//	If right (0)
+	if((testByte & bitTest) == bitTest)
+	{
+		nextNode = GetRight();
+	}
+
+	//	Else left (1)
+	else
+	{
+		nextNode = GetLeft();
+	}
+
+	if(nextNode == NULL)
+	{
+		LogDebug("CHuffmanBranchNode::Decode() - No branch to follow.  Huffman tree hasnt been initialized properly, or is incomplete");
+		*hasFinished = true;
+		return false;
+	}
+
+	//	Once we go past the end of the input buffer, we have finished
+	if(*currentInputByte >= endInputByte)
+	{
+		*hasFinished = true;
+		return true;
+	}
+
+	//	Move to the next bit
+	(*currentInputBit)++;
+	
+	if(*currentInputBit == 8)
+	{
+		*currentInputBit = 0;
+		(*currentInputByte)++;
+		
+	}
+
+	/*
+	//	Once we go past the end of the input buffer, we have finished
+	if(*currentInputByte > endInputByte)
+	{
+		*hasFinished = true;
+		return true;
+	}
+*/
+	//	Pass to the next node in the tree to decode
+	return nextNode->Decode(currentInputByte, currentInputBit, endInputByte, currentOutputByte, endOutputByte, hasFinished);
+}
Index: DirectShowFilters/TsWriter/source/HuffmanBranchNode.h
===================================================================
--- DirectShowFilters/TsWriter/source/HuffmanBranchNode.h	(revision 0)
+++ DirectShowFilters/TsWriter/source/HuffmanBranchNode.h	(revision 0)
@@ -0,0 +1,60 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+#include <windows.h>
+
+
+
+
+class CHuffmanBranchNode
+	: public CHuffmanNode
+{
+public:
+
+	//	Cstr/Flzr
+	CHuffmanBranchNode();
+	~CHuffmanBranchNode();
+
+	//	Sets the left node
+	void SetLeft(CHuffmanNode* newLeft);
+
+	//	Sets the right node
+	void SetRight(CHuffmanNode* newRight);
+
+	//	Gets the left node
+	CHuffmanNode* GetLeft();
+
+	//	Gets the right node
+	CHuffmanNode* GetRight();
+
+	//	Gets the type of the node
+	int GetType();
+
+	//	Traverses the tree to decode the huffman data
+	bool Decode(byte** currentInputByte, byte* currentInputBit, byte* endInputByte, byte** currentOutputByte, byte* endOutputByte, bool* hasFinished);
+
+private:
+	
+	//	Left/Right tree pointer (left=0, right=1)
+	CHuffmanNode* left;
+	CHuffmanNode* right;
+
+};
Index: DirectShowFilters/TsWriter/source/HuffmanLeafNode.cpp
===================================================================
--- DirectShowFilters/TsWriter/source/HuffmanLeafNode.cpp	(revision 0)
+++ DirectShowFilters/TsWriter/source/HuffmanLeafNode.cpp	(revision 0)
@@ -0,0 +1,77 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+
+#include "HuffmanNode.h"
+#include "HuffmanLeafNode.h"
+
+
+
+//	External logging method
+extern void LogDebug(const char *fmt, ...) ;
+
+
+//	Cstr
+CHuffmanLeafNode::CHuffmanLeafNode(char* leafDecodedString)
+{
+	decodedString = leafDecodedString;
+}
+
+//	Gets the type of this node (branch node)
+int CHuffmanLeafNode::GetType()
+{
+	return HUFFMAN_LEAF_NODE;
+}
+
+//	Traverses the tree to decode the huffman data
+bool CHuffmanLeafNode::Decode(byte** currentInputByte, byte* currentInputBit, byte* endInputByte, byte** currentOutputByte, byte* endOutputByte, bool* hasFinished)
+{
+	//	Check we have enough room left in the output buffer
+	int decodedStringLength = strlen(decodedString);
+	int outputBufferBytesLeft = endOutputByte - *currentOutputByte;
+
+	if(decodedStringLength > outputBufferBytesLeft)
+	{
+		LogDebug("CHuffmanLeafNode::Decode() - not enough bytes left in output buffer to hold decoded string");
+
+		//	Failed
+		return false;
+	}
+	/*
+	//	If we are now past the first bit in the last byte of the buffer, we have finished
+	if(*currentInputByte >= endInputByte)// || (*currentInputByte == endInputByte && *currentInputBit >= 1))
+	{
+		*hasFinished = true;
+		return true;
+	}
+*/
+	//LogDebug("Leaf: %s - next bit: %u %u", decodedString, *currentInputByte, *currentInputBit);
+
+	//	Copy the decoded string to the output buffer
+	memcpy(*currentOutputByte, decodedString, decodedStringLength);
+
+	//	Move the output buffer to the new end position
+	*currentOutputByte = *currentOutputByte + decodedStringLength;
+	
+	
+
+	return true;
+}
Index: DirectShowFilters/TsWriter/source/HuffmanLeafNode.h
===================================================================
--- DirectShowFilters/TsWriter/source/HuffmanLeafNode.h	(revision 0)
+++ DirectShowFilters/TsWriter/source/HuffmanLeafNode.h	(revision 0)
@@ -0,0 +1,45 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+
+#include <windows.h>
+
+
+class CHuffmanLeafNode
+	: public CHuffmanNode
+{
+public:
+
+	//	Cstr
+	CHuffmanLeafNode(char* leafDecodedString);
+
+	//	Gets the type of the node
+	int GetType();
+
+	//	Traverses the tree to decode the huffman data
+	bool Decode(byte** currentInputByte, byte* currentInputBit, byte* endInputByte, byte** currentOutputByte, byte* endOutputByte, bool* hasFinished);
+
+private:
+	
+	char* decodedString;
+
+};
+
Index: DirectShowFilters/TsWriter/source/HuffmanNode.cpp
===================================================================
--- DirectShowFilters/TsWriter/source/HuffmanNode.cpp	(revision 0)
+++ DirectShowFilters/TsWriter/source/HuffmanNode.cpp	(revision 0)
@@ -0,0 +1,28 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+
+#include "HuffmanNode.h"
+
+//	Cstr
+CHuffmanNode::CHuffmanNode()
+{
+}
Index: DirectShowFilters/TsWriter/source/HuffmanNode.h
===================================================================
--- DirectShowFilters/TsWriter/source/HuffmanNode.h	(revision 0)
+++ DirectShowFilters/TsWriter/source/HuffmanNode.h	(revision 0)
@@ -0,0 +1,47 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+
+
+#include <windows.h>
+
+
+#define HUFFMAN_BRANCH_NODE 0x01
+#define HUFFMAN_LEAF_NODE	0x02
+
+
+class CHuffmanNode
+{
+public:
+
+	//	Cstr
+	CHuffmanNode();
+
+	//	Gets the type (either branch node or leaf node)
+	virtual int GetType() = 0;
+
+	//	Traverses the tree to decode the huffman data
+	virtual bool Decode(byte** currentInputByte, byte* currentInputBit, byte* endInputByte, byte** currentOutputByte, byte* endOutputByte, bool* hasFinished) = 0;
+
+private:
+	
+
+};
Index: DirectShowFilters/TsWriter/source/HuffmanTree.cpp
===================================================================
--- DirectShowFilters/TsWriter/source/HuffmanTree.cpp	(revision 0)
+++ DirectShowFilters/TsWriter/source/HuffmanTree.cpp	(revision 0)
@@ -0,0 +1,187 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+
+
+#include "HuffmanTree.h"
+
+
+
+//	External logging method
+extern void LogDebug(const char *fmt, ...) ;
+
+// Constr
+CHuffmanTree::CHuffmanTree()
+{
+	trunkNode = NULL;
+}
+
+//	Dstr
+CHuffmanTree::~CHuffmanTree()
+{
+	if(trunkNode != NULL)
+		delete trunkNode;
+}
+
+//	Adds a leaf node decoded string with the specified path
+void CHuffmanTree::AddLeaf(int path, int bitLength, char* decodedString)
+{
+	//	Shift the bits to the left hand side
+	path = path << (32 - bitLength);
+	
+	if(trunkNode == NULL)
+		trunkNode = new CHuffmanBranchNode();
+
+	CHuffmanBranchNode* currentNode = (CHuffmanBranchNode*) trunkNode;
+
+	//	Loop through all the bits to build the tree path for this leaf
+	for(int i = 0; i < bitLength - 1; i++)
+	{		
+		CHuffmanBranchNode* connectingNode = NULL;
+
+		//	If next bit 0, branch left
+		if((path & 0x80000000) == 0x00000000)
+		{		
+			connectingNode = (CHuffmanBranchNode*)currentNode->GetLeft();
+
+			//	Create if doesnt exist
+			if(connectingNode == NULL)
+			{
+				connectingNode = new CHuffmanBranchNode();
+				currentNode->SetLeft(connectingNode);
+			}
+		}
+
+		//	If next bit 1, branch right
+		else
+		{
+			connectingNode = (CHuffmanBranchNode*)currentNode->GetRight();
+
+			//	Create if doesnt exist
+			if(connectingNode == NULL)
+			{
+				connectingNode = new CHuffmanBranchNode();
+				currentNode->SetRight(connectingNode);
+			}
+		}
+
+		//	Move to next bit
+		path = path << 1;
+
+		//	Move to the connecting node
+		currentNode = connectingNode;
+	}
+
+	//	Create the leaf node
+	CHuffmanLeafNode* newLeafNode = new CHuffmanLeafNode(decodedString);
+
+
+	//	Leaf on left
+	if((path & 0x80000000) == 0x00000000)
+	{
+		//	Verify the leaf is empty
+		if(currentNode->GetLeft() != NULL)
+		{
+			LogDebug("CHuffmanTree::AddLeaf() - Error building Huffman tree, leaf node not empty as expected");
+			return;
+		}
+
+		currentNode->SetLeft(newLeafNode);
+
+		//LogDebug("CHuffmanTree::AddLeaf() - Added leaf node for \"%s\" on left", decodedString);
+	}
+
+	//	Leaf on right
+	else
+	{
+		//	Verify the leaf is empty
+		if(currentNode->GetRight() != NULL)
+		{
+			LogDebug("CHuffmanTree::AddLeaf() - Error building Huffman tree, leaf node not empty as expected");
+			return;
+		}
+
+		currentNode->SetRight(newLeafNode);
+		
+		//LogDebug("CHuffmanTree::AddLeaf() - Added leaf node for \"%s\" on right", decodedString);
+	}
+}
+
+//	Decodes the input string using the huffman tree, returning the decoded length
+int CHuffmanTree::Decode(byte* inputBuffer, int inputLength, byte startBit, byte* outputBuffer, int outputLength)
+{
+	byte* currentInputByte = inputBuffer;
+	byte* currentInputBit = &startBit;
+	byte* endInputByte = inputBuffer + inputLength;
+
+	byte* currentOutputByte = outputBuffer;
+	byte* endOutputByte = outputBuffer + outputLength;
+
+	//	Allow for terminating byte
+	outputLength--;	
+
+	//	Safeguard to prevent a bug causing an infinite loop!
+	int i = 0;
+	int maxIterations = 8192;
+
+	//LogDebug("Input length: %u", inputLength);
+
+	try
+	{
+		bool hasFinished = false;
+
+		while(!hasFinished && i < maxIterations)
+		{
+			bool result = trunkNode->Decode(&currentInputByte, currentInputBit, endInputByte, &currentOutputByte, endOutputByte, &hasFinished);
+
+			if(!result)
+			{
+				//LogDebug("CHuffmanTree::Decode() - Error, failed to decode huffman encoded buffer");
+				*outputBuffer = 0;
+				return 0;
+			}
+
+			i++;
+		}
+
+		if(i >= 8192)
+		{
+			LogDebug("CHuffmanTree::Decode - Error parsing decoded buffer, max iterations exceeded");
+			*outputBuffer = 0;
+			return 0;
+		}
+	}
+	catch(...)
+	{
+		LogDebug("CHuffmanTree::Decode - Exception whilst decoding input buffer");
+		return 0;
+	}
+
+	//	Add a terminating character to the output buffer
+	*currentOutputByte = 0;
+
+	//LogDebug("CHuffmanTree::Decode - Item decoded successfully:");
+	//LogDebug(outputBuffer);
+
+	
+	//	Return the decoded output length
+	return currentOutputByte - outputBuffer;
+}
Index: DirectShowFilters/TsWriter/source/HuffmanTree.h
===================================================================
--- DirectShowFilters/TsWriter/source/HuffmanTree.h	(revision 0)
+++ DirectShowFilters/TsWriter/source/HuffmanTree.h	(revision 0)
@@ -0,0 +1,47 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+#include <windows.h>
+#include "HuffmanNode.h"
+#include "HuffmanBranchNode.h"
+#include "HuffmanLeafNode.h"
+
+
+
+class CHuffmanTree
+{
+public:
+
+	//	Cstr/destr
+	CHuffmanTree();
+	~CHuffmanTree();
+
+	//	Adds a leaf node to the tree
+	void AddLeaf(int path, int length, char* decodedString);
+
+	//	Decodes the input string using the huffman tree, returning the decoded length
+	int Decode(byte* input, int inputLength, byte startBit, byte* output, int outputLength);
+
+private:
+
+	CHuffmanNode* trunkNode;
+
+};
Index: DirectShowFilters/TsWriter/source/MhwParser.cpp
===================================================================
--- DirectShowFilters/TsWriter/source/MhwParser.cpp	(revision 27484)
+++ DirectShowFilters/TsWriter/source/MhwParser.cpp	(working copy)
@@ -114,6 +114,10 @@
 	try
 	{
 		CEnterCriticalSection enter(m_section);
+
+		if(m_bDone)
+			return;
+
 //		LogDebug("mhw new section pid:%x tableid:%x %x %x len:%d",pid,tableId,sections.Data[4],sections.Data[5],sections.Data[6], sections.SectionLength);
 		if (!IsSectionWanted(pid,tableId)) return;
 
@@ -191,10 +195,14 @@
 bool	CMhwParser::IsEPGReady()
 {
 	CEnterCriticalSection enter(m_section);
+
+	if(m_bDone)
+		return true;
+
 	int passed=(int)(time(NULL)-m_TimeOutTimer);
   if (passed>=30)
   {
-    LogDebug("mhw grabber ended");
+    //LogDebug("mhw grabber ended");
 	  m_bDone=true;
 	  m_bGrabbing=false;
   }
